package lu.uni.timed_mutation.mutantgenerationviolation;

import java.util.List;

import org.w3c.dom.Node;

public class TransitionAddedControllable extends TransitionAddedMutation {
	
	@Override
	public boolean apply(Model m, int index) {
		assert(index < getNumberOfMutations(m) && getNumberOfMutations(m) > 0);
		
		Node template = m.transitionsWithActions().get(0).cloneNode(true);
		
		if (template.getAttributes().getNamedItem("controllable")!=null)
			template.getAttributes().getNamedItem("controllable").setTextContent("true");
		
		Node transAction = m.action(template);
		transAction.setTextContent("dummyInput"+(m.hashCode()+index)+"?");
		
		m.addIO("dummyInput"+(m.hashCode()+index), "?");

		Node transSource = Model.children(template, "source").get(0);
		Node transTarget = Model.children(template, "target").get(0);
		
		Node automaton = m.automata().get(0);
		List<Node> locations = m.locations(automaton);
		Node source = locations.get(index / m.locations(automaton).size());
		Node target = locations.get(index % m.locations(automaton).size());
		
		transSource.getAttributes().getNamedItem("ref").setTextContent(
				source.getAttributes().getNamedItem("id").getTextContent());
		
		transTarget.getAttributes().getNamedItem("ref").setTextContent(
				target.getAttributes().getNamedItem("id").getTextContent());

		automaton.appendChild(template);
				
		index++;
		//String src = Model.children(template, "source").get(0).getAttributes().getNamedItem("ref").getTextContent();
		//String tgt = Model.children(template, "target").get(0).getAttributes().getNamedItem("ref").getTextContent();
		//System.out.println(name() + "#" + (index) + " Added transition: " + src + " -> " + tgt + " / " +template.getTextContent());
		
		return true;
	}

	@Override
	public String name() {
		return "TAD-C";
	}

	@Override
	public int getNumberOfMutations(Model m) {
		return m.locations().size() * m.locations().size();
	}


}
